import java.io.InputStream;
import java.io.OutputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.spec.InvalidKeySpecException;

import javax.crypto.Cipher;
import javax.crypto.CipherOutputStream;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import javax.crypto.spec.IvParameterSpec;

public class DESSTR {

	Cipher ecipher;
	Cipher dcipher;
	byte[] buf = new byte[1024];

	public DESSTR() {
		String strKey = "c7cbc28f2f1abf4f";
		strKey = "12345678";
		byte[] keyBytes = null;
		try {
			keyBytes = strKey.getBytes("UTF-8");
		} catch (java.io.UnsupportedEncodingException ex) {
			ex.printStackTrace();
		}
		// byte[] iv = new byte[] { '0', '1', '2', '3', '4', '5', '6', '7', '0',
		// '1', '2', '3', '4', '5', '6', '7' };
		byte[] iv = "01234567".getBytes();
		IvParameterSpec ivSpec = new IvParameterSpec(iv);
		try {
			ecipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
			dcipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		}
		try {
			//SecretKeySpec securekey = new SecretKeySpec(keyBytes, "DES");

			DESKeySpec dks = new DESKeySpec(keyBytes);
			SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
			SecretKey securekey = keyFactory.generateSecret(dks);
			
			//KeyGenerator generator = KeyGenerator.getInstance("DES");
			//generator.init(new SecureRandom(keyBytes));
			//SecretKey securekey = generator.generateKey();
			ecipher.init(Cipher.ENCRYPT_MODE, securekey, ivSpec);
			dcipher.init(Cipher.DECRYPT_MODE, securekey, ivSpec);
//			System.out.println("getBlockSize(): " + ecipher.getBlockSize());
//			System.out.println("getAlgorithm(): " + ecipher.getAlgorithm());
//			System.out.println("getIV(): " + new String(ecipher.getIV()));
		} catch (InvalidKeyException e1) {
			e1.printStackTrace();
		} catch (InvalidAlgorithmParameterException e1) {
			e1.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (InvalidKeySpecException e) {
			e.printStackTrace();
		}
	}

	public void encrypt(InputStream in, OutputStream out) {
		try {
			out = new CipherOutputStream(out, ecipher);
			int numRead = 0;
			while ((numRead = in.read(buf)) >= 0) {
				out.write(buf, 0, numRead);
			}
			out.close();
		} catch (java.io.IOException e) {
			e.printStackTrace();
		}
	}
	
	public byte[] encrptyStr(byte[] bIn) {
		try {
			return ecipher.doFinal(bIn);
		}catch (Exception e) {
			e.printStackTrace();
		}
		return new byte[]{};
	}

	public void decrypt(InputStream in, OutputStream out) {
		try {
			out = new CipherOutputStream(out, dcipher);
			int numRead = 0;
			while ((numRead = in.read(buf)) >= 0) {
				out.write(buf, 0, numRead);
			}
			out.close();
		} catch (java.io.IOException e) {
			e.printStackTrace();
		}
	}

	public byte[] decrptyStr(byte[] bIn) {
		try {
			return dcipher.doFinal(bIn);
		}catch (Exception e) {
			e.printStackTrace();
		}
		return new byte[]{};
	}
	
	public static String byte2hex(byte[] b) {
		String hs = "";
		String stmp = "";
		for (int n = 0; n < b.length; n++) {
			stmp = (Integer.toHexString(b[n] & 0XFF));
			if (stmp.length() == 1)
				hs = hs + "0" + stmp;
			else
				hs = hs + stmp;
		}
		return hs.toUpperCase();
	}

	public static byte[] hex2byte(byte[] b) {
		if ((b.length % 2) != 0)
			throw new IllegalArgumentException("Length is not even");
		byte[] b2 = new byte[b.length / 2];
		for (int n = 0; n < b.length; n += 2) {
			String item = new String(b, n, 2);
			b2[n / 2] = (byte) Integer.parseInt(item, 16);
		}
		return b2;
	}
	
	public static String byte2String(byte[] b) {
		String hs = "";
		String stmp = "";
		for (int n = 0; n < b.length; n++) {
			stmp = (Integer.toHexString(b[n] & 0XFF));
			hs += Character.valueOf((char)Integer.parseInt(stmp, 16)).toString();
		}
		return hs;
	}
	
	public static void main(String args[]) throws Exception {
		if (args.length == 0) {
			System.err.println("Need a string!");
			System.exit(1);
		}
		DESSTR encrypter = new DESSTR();
		byte[] in = hex2byte(args[0].getBytes("UTF-8"));
//		System.out.println("in length: " + in.length); 
//		for (int i = 0; i < in.length; i ++) {
//			System.out.println(i + ": " + in[i]);
//		}
//		System.out.println(new String(in));
//		System.out.println("--------------");
		byte[] out = encrypter.decrptyStr(in);
		System.out.println(new String(out));
		
//		byte[] inin = args[0].getBytes("UTF-8");
//		byte[] outout = encrypter.encrptyStr(inin);
//		System.out.println(new String(outout));
//		String str = byte2hex(outout);
//		System.out.println(str);
//		byte[] in = hex2byte(str.getBytes("UTF-8"));
//		byte[] out = encrypter.decrptyStr(in);
//		System.out.println(new String(out));

	}
}
